uqmi: use correct value for connection checking
[oweals/openwrt.git] / package / network / utils / uqmi / files / lib / netifd / proto / qmi.sh
1 #!/bin/sh
2
3 [ -n "$INCLUDE_ONLY" ] || {
4         . /lib/functions.sh
5         . ../netifd-proto.sh
6         init_proto "$@"
7 }
8
9 proto_qmi_init_config() {
10         available=1
11         no_device=1
12         proto_config_add_string "device:device"
13         proto_config_add_string apn
14         proto_config_add_string auth
15         proto_config_add_string username
16         proto_config_add_string password
17         proto_config_add_string pincode
18         proto_config_add_int delay
19         proto_config_add_string modes
20         proto_config_add_string pdptype
21         proto_config_add_int profile
22         proto_config_add_boolean dhcpv6
23         proto_config_add_boolean autoconnect
24         proto_config_add_int plmn
25         proto_config_add_defaults
26 }
27
28 proto_qmi_setup() {
29         local interface="$1"
30         local dataformat
31         local device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn $PROTO_DEFAULT_OPTIONS
32         local cid_4 pdh_4 cid_6 pdh_6
33         local ip_6 ip_prefix_length gateway_6 dns1_6 dns2_6
34         json_get_vars device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn $PROTO_DEFAULT_OPTIONS
35
36         [ "$metric" = "" ] && metric="0"
37
38         [ -n "$ctl_device" ] && device=$ctl_device
39
40         [ -n "$device" ] || {
41                 echo "No control device specified"
42                 proto_notify_error "$interface" NO_DEVICE
43                 proto_set_available "$interface" 0
44                 return 1
45         }
46
47         device="$(readlink -f $device)"
48         [ -c "$device" ] || {
49                 echo "The specified control device does not exist"
50                 proto_notify_error "$interface" NO_DEVICE
51                 proto_set_available "$interface" 0
52                 return 1
53         }
54
55         devname="$(basename "$device")"
56         devpath="$(readlink -f /sys/class/usbmisc/$devname/device/)"
57         ifname="$( ls "$devpath"/net )"
58         [ -n "$ifname" ] || {
59                 echo "The interface could not be found."
60                 proto_notify_error "$interface" NO_IFACE
61                 proto_set_available "$interface" 0
62                 return 1
63         }
64
65         [ -n "$delay" ] && sleep "$delay"
66
67         while uqmi -s -d "$device" --get-pin-status | grep '"UIM uninitialized"' > /dev/null; do
68                 [ -e "$device" ] || return 1
69                 sleep 1;
70         done
71
72         [ -n "$pincode" ] && {
73                 uqmi -s -d "$device" --verify-pin1 "$pincode" > /dev/null || uqmi -s -d "$device" --uim-verify-pin1 "$pincode" > /dev/null || {
74                         echo "Unable to verify PIN"
75                         proto_notify_error "$interface" PIN_FAILED
76                         proto_block_restart "$interface"
77                         return 1
78                 }
79         }
80
81         [ -n "$plmn" ] && {
82                 local mcc mnc
83                 if [ "$plmn" = 0 ]; then
84                         mcc=0
85                         mnc=0
86                         echo "Setting PLMN to auto"
87                 else
88                         mcc=${plmn:0:3}
89                         mnc=${plmn:3}
90                         echo "Setting PLMN to $plmn"
91                 fi
92                 uqmi -s -d "$device" --set-plmn --mcc "$mcc" --mnc "$mnc" || {
93                         echo "Unable to set PLMN"
94                         proto_notify_error "$interface" PLMN_FAILED
95                         proto_block_restart "$interface"
96                         return 1
97                 }
98         }
99
100         # Cleanup current state if any
101         uqmi -s -d "$device" --stop-network 0xffffffff --autoconnect
102
103         # Set IP format
104         uqmi -s -d "$device" --set-data-format 802.3
105         uqmi -s -d "$device" --wda-set-data-format 802.3
106         dataformat="$(uqmi -s -d "$device" --wda-get-data-format)"
107
108         if [ "$dataformat" = '"raw-ip"' ]; then
109
110                 [ -f /sys/class/net/$ifname/qmi/raw_ip ] || {
111                         echo "Device only supports raw-ip mode but is missing this required driver attribute: /sys/class/net/$ifname/qmi/raw_ip"
112                         return 1
113                 }
114
115                 echo "Device does not support 802.3 mode. Informing driver of raw-ip only for $ifname .."
116                 echo "Y" > /sys/class/net/$ifname/qmi/raw_ip
117         fi
118
119         uqmi -s -d "$device" --sync
120
121         echo "Waiting for network registration"
122         while uqmi -s -d "$device" --get-serving-system | grep '"searching"' > /dev/null; do
123                 [ -e "$device" ] || return 1
124                 sleep 5;
125         done
126
127         [ -n "$modes" ] && uqmi -s -d "$device" --set-network-modes "$modes"
128
129         echo "Starting network $interface"
130
131         pdptype=$(echo "$pdptype" | awk '{print tolower($0)}')
132         [ "$pdptype" = "ip" -o "$pdptype" = "ipv6" -o "$pdptype" = "ipv4v6" ] || pdptype="ip"
133
134         if [ "$pdptype" = "ip" ]; then
135                 [ -z "$autoconnect" ] && autoconnect=1
136                 [ "$autoconnect" = 0 ] && autoconnect=""
137         else
138                 [ "$autoconnect" = 1 ] || autoconnect=""
139         fi
140
141         [ "$pdptype" = "ip" -o "$pdptype" = "ipv4v6" ] && {
142                 cid_4=$(uqmi -s -d "$device" --get-client-id wds)
143                 [ $? -ne 0 ] && {
144                         echo "Unable to obtain client ID"
145                         proto_notify_error "$interface" NO_CID
146                         return 1
147                 }
148
149                 uqmi -s -d "$device" --set-client-id wds,"$cid_4" --set-ip-family ipv4 > /dev/null
150
151                 pdh_4=$(uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
152                         --start-network \
153                         ${apn:+--apn $apn} \
154                         ${profile:+--profile $profile} \
155                         ${auth:+--auth-type $auth} \
156                         ${username:+--username $username} \
157                         ${password:+--password $password} \
158                         ${autoconnect:+--autoconnect})
159
160         # pdh_4 is a numeric value on success
161                 if ! [ "$pdh_4" -eq "$pdh_4" ] 2> /dev/null; then
162                         echo "Unable to connect IPv4"
163                         uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
164                         proto_notify_error "$interface" CALL_FAILED
165                         return 1
166                 fi
167         }
168
169         [ "$pdptype" = "ipv6" -o "$pdptype" = "ipv4v6" ] && {
170                 cid_6=$(uqmi -s -d "$device" --get-client-id wds)
171                 [ $? -ne 0 ] && {
172                         echo "Unable to obtain client ID"
173                         proto_notify_error "$interface" NO_CID
174                         return 1
175                 }
176
177                 uqmi -s -d "$device" --set-client-id wds,"$cid_6" --set-ip-family ipv6 > /dev/null
178
179                 pdh_6=$(uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
180                         --start-network \
181                         ${apn:+--apn $apn} \
182                         ${profile:+--profile $profile} \
183                         ${auth:+--auth-type $auth} \
184                         ${username:+--username $username} \
185                         ${password:+--password $password} \
186                         ${autoconnect:+--autoconnect})
187
188         # pdh_6 is a numeric value on success
189                 if ! [ "$pdh_6" -eq "$pdh_6" ] 2> /dev/null; then
190                         echo "Unable to connect IPv6"
191                         uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
192                         proto_notify_error "$interface" CALL_FAILED
193                         return 1
194                 fi
195         }
196
197         echo "Setting up $ifname"
198         proto_init_update "$ifname" 1
199         proto_set_keep 1
200         proto_add_data
201         [ -n "$pdh_4" ] && {
202                 json_add_string "cid_4" "$cid_4"
203                 json_add_string "pdh_4" "$pdh_4"
204         }
205         [ -n "$pdh_6" ] && {
206                 json_add_string "cid_6" "$cid_6"
207                 json_add_string "pdh_6" "$pdh_6"
208         }
209         proto_close_data
210         proto_send_update "$interface"
211         [ -n "$pdh_6" ] && {
212                 if [ -z "$dhcpv6" -o "$dhcpv6" = 0 ]; then
213                         json_load "$(uqmi -s -d $device --set-client-id wds,$cid_6 --get-current-settings)"
214                         json_select ipv6
215                         json_get_var ip_6 ip
216                         json_get_var gateway_6 gateway
217                         json_get_var dns1_6 dns1
218                         json_get_var dns2_6 dns2
219                         json_get_var ip_prefix_length ip-prefix-length
220
221                         proto_init_update "$ifname" 1
222                         proto_set_keep 1
223                         proto_add_ipv6_address "$ip_6" "128"
224                         proto_add_ipv6_prefix "${ip_6}/${ip_prefix_length}"
225                         proto_add_ipv6_route "$gateway_6" "128"
226                         [ "$defaultroute" = 0 ] || proto_add_ipv6_route "::0" 0 "$gateway_6" "" "" "${ip_6}/${ip_prefix_length}"
227                         [ "$peerdns" = 0 ] || {
228                                 proto_add_dns_server "$dns1_6"
229                                 proto_add_dns_server "$dns2_6"
230                         }
231                         proto_send_update "$interface"
232                 else
233                         json_init
234                         json_add_string name "${interface}_6"
235                         json_add_string ifname "@$interface"
236                         json_add_string proto "dhcpv6"
237                         proto_add_dynamic_defaults
238                         # RFC 7278: Extend an IPv6 /64 Prefix to LAN
239                         json_add_string extendprefix 1
240                         json_close_object
241                         ubus call network add_dynamic "$(json_dump)"
242                 fi
243         }
244
245         [ -n "$pdh_4" ] && {
246                 json_init
247                 json_add_string name "${interface}_4"
248                 json_add_string ifname "@$interface"
249                 json_add_string proto "dhcp"
250                 proto_add_dynamic_defaults
251                 json_close_object
252                 ubus call network add_dynamic "$(json_dump)"
253         }
254 }
255
256 qmi_wds_stop() {
257         local cid="$1"
258         local pdh="$2"
259
260         [ -n "$cid" ] || return
261
262         uqmi -s -d "$device" --set-client-id wds,"$cid" \
263                 --stop-network 0xffffffff \
264                 --autoconnect > /dev/null
265
266         [ -n "$pdh" ] && uqmi -s -d "$device" --set-client-id wds,"$cid" --stop-network "$pdh"
267         uqmi -s -d "$device" --set-client-id wds,"$cid" --release-client-id wds
268 }
269
270 proto_qmi_teardown() {
271         local interface="$1"
272
273         local device cid_4 pdh_4 cid_6 pdh_6
274         json_get_vars device
275
276         [ -n "$ctl_device" ] && device=$ctl_device
277
278         echo "Stopping network $interface"
279
280         json_load "$(ubus call network.interface.$interface status)"
281         json_select data
282         json_get_vars cid_4 pdh_4 cid_6 pdh_6
283
284         qmi_wds_stop "$cid_4" "$pdh_4"
285         qmi_wds_stop "$cid_6" "$pdh_6"
286
287         proto_init_update "*" 0
288         proto_send_update "$interface"
289 }
290
291 [ -n "$INCLUDE_ONLY" ] || {
292         add_protocol qmi
293 }